require 'date'
require 'roxml'
require_relative '../../mastercard_merchant_onboarding/models/validated_merchant'
 

module MastercardMerchantOnboarding
  # This class contains the 3DS and/or non-3DS merchant status records.
  class ValidateFileResponse
    include ROXML
    
    xml_name "ValidateFileResponse"
    
    # @!attribute validated_merchant
    # @return [Array<ValidatedMerchant>] the validation details of a merchant.
    xml_accessor :validated_merchant, :from =>"ValidatedMerchant", :as =>[ValidatedMerchant]
   
    # @!attribute error_text
    # @return [String] the description of validation error.
    xml_accessor :error_text, :from =>"ErrorText"
   

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :validated_merchant => :ValidatedMerchant ,
        :error_text => :ErrorText 
        
      }
    end

    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.inject({}){|memo,(k,v)| memo[k.to_sym] = v; memo}

      
      if attributes.has_key?(:validated_merchant)
        self.validated_merchant = attributes[:validated_merchant]
      end
      
      if attributes.has_key?(:error_text)
        self.error_text = attributes[:error_text]
      end
      
    end
    
 
    # Overriding setter method validated_merchant
    # @param value 
  	def validated_merchant=(value)
      if (value.is_a?(Array))
        @validated_merchant = value
      else
        @validated_merchant = [] if !@validated_merchant
        @validated_merchant.push value
      end
    end
	

    # Check equality by comparing each attribute.
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          validated_merchant == o.validated_merchant &&
          error_text == o.error_text
    end

    # @see the `==` method
    def eql?(o)
      self == o
    end

    # Calculate hash code according to all attributes.
    def hash
      [validated_merchant, error_text].hash
    end

    # build the object from hash
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.datatype_map.each_pair do |key, type|
        if type =~ /^Array<(.*)>/i
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map{ |v| _deserialize($1, v) } )
          else
            #TODO show warning in debug mode
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        else
          # data not found in attributes(hash), not an issue as the data can be optional
        end
      end

      self
    end

    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :Object
      	value
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k).to_sym] = _deserialize(v_type, v)
          end
        end
      else # model
        _model = MastercardMerchantOnboarding.const_get(type).new
        _model.build_from_hash(value)
      end
    end

    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_body (backward compatibility))
    def to_body
      to_hash
    end

    # return the object in the form of hash
    def to_hash(include_root = false)
      attributes_hash = {} 
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      attributes_hash = include_root ? { "ValidateFileResponse" => hash } : hash  
      return attributes_hash
    end

    # Method to output non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map{ |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end


    private
    def after_parse
      self.send(:remove_instance_variable, :@roxml_references) if defined? self.roxml_references
    end
    
    # Attribute datatype mapping.
    def self.datatype_map
      {
        :validated_merchant => 'Array<ValidatedMerchant>',
        :error_text => 'String'
        
      }
    end
  end


end
